//still to be added: godmode, infinite ammo, save tp location, option tp, invis/setvis (convert both vis functions to use a percentage multiplier for alpha values), teamswitch, teamban, knifeonly, weaponstrip, bots
//coded, but needs to be added to menu still: weapons, speed, hp, getmodel, forcemodel
//events to add: round start for reset vis
//team change

//need to set replytocommand for whenever not reporting in chat.
//some menu items need to be fixed.

#pragma semicolon 1

#include <sourcemod>
#include <adminmenu>
#include <sdktools>
#include <autoexecconfig>
#include <cstrike>

#define PLUGIN_VERSION "1.1.0"
#define TAG "[TOG Ext Adm] "
#pragma newdecls required
Handle g_hNoChatLogFlags = null;
char g_sNoChatLogFlags[30];
Handle g_hRespawnFlag = null;
char g_sRespawnFlag[30];
Handle g_hTeleportFlag = null;
char g_sTeleportFlag[30];
int g_iDisableTP[MAXPLAYERS+1] = {0,...};
Handle g_hKnifeFlag = null;
char g_sKnifeFlag[30];
Handle g_hWeaponFlag = null;
char g_sWeaponFlag[30];
Handle g_hCashFlag = null;
char g_sCashFlag[30];
Handle g_hHPFlag = null;
char g_sHPFlag[30];
Handle g_hSpeedFlag = null;
char g_sSpeedFlag[30];
Handle g_hGodModeFlag = null;
char g_sGodModeFlag[30];
int g_iGodMode[MAXPLAYERS+1] = {0,...};
Handle g_hResizeFlag = null;
char g_sResizeFlag[30];
bool g_bHitboxAvailable = false;
Handle g_hAmmoFlag = INVALID_HANDLE;
char g_sAmmoFlag[30];
bool g_bAmmoFlag[MAXPLAYERS+1] = {false,...};
Handle g_hScoreFlag = null;
char g_sScoreFlag[30];
Handle g_hExecFlag = null;
char g_sExecFlag[30];
Handle g_hModelFlag = null;
char g_sModelFlag[30];
Handle g_hOverlayFlag = null;
char g_sOverlayFlag[30];
Handle g_hMapTimeFlag = null;
char g_sMapTimeFlag[30];
Handle g_hTimelimit = null; //handle to get cvar

Handle g_hAdminMenu;		//admin menu handle

char sDebugPath[PLATFORM_MAX_PATH];
//LogToFileEx(sDebugPath, "");

bool g_bCSGO = false;

public Plugin myinfo =
{
	name = "TOG Extended Admin",
	author = "That One Guy",
	description = "Extended admin commands",
	version = PLUGIN_VERSION,
	url = "http://www.togcoding.com"
};


//////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////// EVENTS ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

public void OnPluginStart()
{
	char sGame[32];
	GetGameFolderName(sGame, sizeof(sGame));
	if(StrEqual(sGame, "csgo", false))
	{
		g_bCSGO = true;
	}
	else
	{
		g_bCSGO = false;
	}
	
	LoadTranslations("core.phrases");
	LoadTranslations("common.phrases");
	
	//NOTE: Admin menu is set to generic flag. This cvar will change command access only.
	//However, admin menu executes the command, so, they can use the menu, but when they reach the end they will be blocked.
	
	/////////////////////////////////////////////////////////////////////
	/////////////////////////////// CVARS ///////////////////////////////
	/////////////////////////////////////////////////////////////////////
	AutoExecConfig_SetFile("togextendedadmin");
	AutoExecConfig_CreateConVar("tea_version", PLUGIN_VERSION, "TOG Super Admin: Version", FCVAR_NOTIFY|FCVAR_DONTRECORD);
	
	g_hNoChatLogFlags = CreateConVar("tea_nochatlogflags", "none", "Admins with any of these flags will not have their actions show in chat (but they will still be logged).", _);
	HookConVarChange(g_hNoChatLogFlags, OnCVarChange);
	GetConVarString(g_hNoChatLogFlags, g_sNoChatLogFlags, sizeof(g_sNoChatLogFlags));
	
	g_hRespawnFlag = CreateConVar("tea_respawnflag", "l", "Admins with this flag will be able to respawn players.", _);
	HookConVarChange(g_hRespawnFlag, OnCVarChange);
	GetConVarString(g_hRespawnFlag, g_sRespawnFlag, sizeof(g_sRespawnFlag));
	
	g_hTeleportFlag = AutoExecConfig_CreateConVar("tea_teleportflag", "g", "Admins with this flag will be able to use teleport commands.");
	HookConVarChange(g_hTeleportFlag, OnCVarChange);
	GetConVarString(g_hTeleportFlag, g_sTeleportFlag, sizeof(g_sTeleportFlag));
	
	g_hKnifeFlag = AutoExecConfig_CreateConVar("tea_knifeflag", "b", "Admins with this flag will be able to give knives.");
	HookConVarChange(g_hKnifeFlag, OnCVarChange);
	GetConVarString(g_hKnifeFlag, g_sKnifeFlag, sizeof(g_sKnifeFlag));
	
	g_hWeaponFlag = AutoExecConfig_CreateConVar("tea_weaponflag", "z", "Admins with this flag will be able to give weapons.");
	HookConVarChange(g_hWeaponFlag, OnCVarChange);
	GetConVarString(g_hWeaponFlag, g_sWeaponFlag, sizeof(g_sWeaponFlag));
	
	g_hCashFlag = AutoExecConfig_CreateConVar("tea_cashflag", "g", "Admins with this flag will be able to set/give cash.");
	HookConVarChange(g_hCashFlag, OnCVarChange);
	GetConVarString(g_hCashFlag, g_sCashFlag, sizeof(g_sCashFlag));
	
	g_hHPFlag = AutoExecConfig_CreateConVar("tea_hpflag", "z", "Admins with this flag will be able to set/give hp.");
	HookConVarChange(g_hHPFlag, OnCVarChange);
	GetConVarString(g_hHPFlag, g_sHPFlag, sizeof(g_sHPFlag));
	
	g_hSpeedFlag = AutoExecConfig_CreateConVar("tea_speedflag", "z", "Admins with this flag will be able to players speed.");
	HookConVarChange(g_hSpeedFlag, OnCVarChange);
	GetConVarString(g_hSpeedFlag, g_sSpeedFlag, sizeof(g_sSpeedFlag));
	
	g_hGodModeFlag = AutoExecConfig_CreateConVar("tea_gmflag", "z", "Admins with this flag will be able to give god mode.");
	HookConVarChange(g_hGodModeFlag, OnCVarChange);
	GetConVarString(g_hGodModeFlag, g_sGodModeFlag, sizeof(g_sGodModeFlag));
	
	g_hAmmoFlag = AutoExecConfig_CreateConVar("tea_ammolag", "z", "Admins with this flag will be able to set unlimited ammo options.");
	HookConVarChange(g_hAmmoFlag, OnCVarChange);
	GetConVarString(g_hAmmoFlag, g_sAmmoFlag, sizeof(g_sAmmoFlag));
	
	g_hScoreFlag = AutoExecConfig_CreateConVar("tea_scoreflag", "z", "Admins with this flag will be able to set players frags/deaths.");
	HookConVarChange(g_hScoreFlag, OnCVarChange);
	GetConVarString(g_hScoreFlag, g_sScoreFlag, sizeof(g_sScoreFlag));
	
	g_hExecFlag = AutoExecConfig_CreateConVar("tea_execflag", "z", "Admins with this flag will be able to use cexec/fexec commands.");
	HookConVarChange(g_hExecFlag, OnCVarChange);
	GetConVarString(g_hExecFlag, g_sExecFlag, sizeof(g_sExecFlag));
	
	g_hModelFlag = AutoExecConfig_CreateConVar("tea_modelflag", "z", "Admins with this flag will be able to set player models.");
	HookConVarChange(g_hModelFlag, OnCVarChange);
	GetConVarString(g_hModelFlag, g_sModelFlag, sizeof(g_sModelFlag));
	
	g_hOverlayFlag = AutoExecConfig_CreateConVar("tea_overlayflag", "z", "Admins with this flag will be able to set overlays on players screens.");
	HookConVarChange(g_hOverlayFlag, OnCVarChange);
	GetConVarString(g_hOverlayFlag, g_sOverlayFlag, sizeof(g_sOverlayFlag));
	
	g_hResizeFlag = AutoExecConfig_CreateConVar("tea_resizeflag", "z", "Admins with this flag will be able to resize players and entities.");
	HookConVarChange(g_hResizeFlag, OnCVarChange);
	GetConVarString(g_hResizeFlag, g_sResizeFlag, sizeof(g_sResizeFlag));
	
	g_hMapTimeFlag = AutoExecConfig_CreateConVar("tea_maptimeflag", "g", "Admins with this flag will be able to change cvar mp_timelimit.");
	HookConVarChange(g_hMapTimeFlag, OnCVarChange);
	GetConVarString(g_hMapTimeFlag, g_sMapTimeFlag, sizeof(g_sMapTimeFlag));
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	/////////////////////////////////////////////////////////////////////
	/////////////////////////// ADMIN COMMANDS //////////////////////////
	/////////////////////////////////////////////////////////////////////
	
	//PerformTeleport module
	RegConsoleCmd("sm_bring", Command_Bring, "Teleport target to yourself.");
	RegConsoleCmd("sm_obring", Command_OBring, "Bring players to yourself if they dont have the option disabled.");
	RegConsoleCmd("sm_goto", Command_Goto, "Teleport to a player.");
	RegConsoleCmd("sm_send", Command_Send, "Teleport target to a player.");
	RegConsoleCmd("sm_osend", Command_OSend, "Teleport target to a player if they dont have the option disabled.");

	//GiveItem module
	RegConsoleCmd("sm_knife", Command_Knife, "Gives knife to target.");
	RegConsoleCmd("sm_weapon", Command_Weapon, "Gives weapon to target.");
	
	//misc.
	RegConsoleCmd("sm_respawn", Command_Respawn, "Respawns target.");
	RegConsoleCmd("sm_tp", Command_TP, "Teleport target to your crosshairs.");
	RegConsoleCmd("sm_fexec", Command_FExec, "Fake-execute command on target.");
	RegConsoleCmd("sm_cexec", Command_CExec, "Execute client command on target.");
	RegConsoleCmd("sm_setmodel", Command_ForceModel, "Set model for target.");
	RegConsoleCmd("sm_setentmodel", Command_SetEntModel, "Set model for entities.");
	RegConsoleCmd("sm_speed", Command_Speed, "Set speed multiplier for target.");
	RegConsoleCmd("sm_gm", Command_GodMode, "Toggles god mode on target.");
	RegConsoleCmd("sm_frags", Command_Frags, "Set targets frags.");
	RegConsoleCmd("sm_deaths", Command_Deaths, "Set targets deaths.");
	RegConsoleCmd("sm_cash", Command_Cash, "Give cash to target.");
	RegConsoleCmd("sm_setcash", Command_SetCash, "Set cash value for target.");
	RegConsoleCmd("sm_hp", Command_SetHP, "Set hp value for target.");
	RegConsoleCmd("sm_overlay", Command_Overlay, "Display overlay to target");
	RegConsoleCmd("sm_resize", Command_Resize, "Resize a player");
	RegConsoleCmd("sm_resizeent", Command_ResizeEnt, "Resize an entity");
	RegConsoleCmd("sm_maptime", Command_MapTime, "Sets cvar mp_timelimit");
	RegConsoleCmd("sm_extendmap", Command_ExtendMapTime, "Extends map time limit");
	
	RegConsoleCmd("sm_setpropfloat", Command_SetPropFloat, "Set entity property float");
	RegConsoleCmd("sm_setpropint", Command_SetPropInt, "Set entity property integer");
	
	/////////////////////////////////////////////////////////////////////
	////////////////////////// PLAYER COMMANDS //////////////////////////
	/////////////////////////////////////////////////////////////////////
	
	RegConsoleCmd("sm_disabletp", Command_DisableTP, "Disables being able to be moved by the sm_cbring command.");
	RegConsoleCmd("sm_enabletp", Command_EnableTP, "Enables being able to be moved by the sm_cbring command.");
	RegConsoleCmd("sm_getmodel", Command_GetModel, "Get the model path, if applicable, of the model your crosshairs is on");
	
	/////////////////////////////////////////////////////////////////////
	/////////////////////////////// EVENTS //////////////////////////////
	/////////////////////////////////////////////////////////////////////
	
	HookEvent("round_start", OnRoundStart, EventHookMode_Post);
	HookEvent("weapon_fire", Event_WeaponFire);
	
	/////////////////////////////////////////////////////////////////////
	//////////////////////////////// MISC ///////////////////////////////
	/////////////////////////////////////////////////////////////////////
	
	if(LibraryExists("adminmenu"))
	{
		Handle hTopMenu = GetAdminTopMenu();
		if(hTopMenu != null)
		{
			OnAdminMenuReady(hTopMenu);
		}
	}
	
	BuildPath(Path_SM, sDebugPath, sizeof(sDebugPath), "logs/test.log");
	//hitbox resize
	g_bHitboxAvailable = ((FindSendPropInfo("CBasePlayer", "m_vecSpecifiedSurroundingMins") != -1) && FindSendPropInfo("CBasePlayer", "m_vecSpecifiedSurroundingMaxs") != -1);
	
	//create admin filters
	AddMultiTargetFilter("@admins", adminfilter, "admins", true);
	AddMultiTargetFilter("@!admins", nonadminfilter, "non admins", true);
}

public void OnCVarChange(Handle cvar, const char[] oldvalue, const char[] newvalue)
{
	if(cvar == g_hTeleportFlag)
	{
		GetConVarString(g_hTeleportFlag, g_sTeleportFlag, sizeof(g_sTeleportFlag));
	}
	else if(cvar == g_hRespawnFlag)
	{
		GetConVarString(g_hRespawnFlag, g_sRespawnFlag, sizeof(g_sRespawnFlag));
	}
	else if(cvar == g_hKnifeFlag)
	{
		GetConVarString(g_hKnifeFlag, g_sKnifeFlag, sizeof(g_sKnifeFlag));
	}
	else if(cvar == g_hWeaponFlag)
	{
		GetConVarString(g_hWeaponFlag, g_sWeaponFlag, sizeof(g_sWeaponFlag));
	}
	else if(cvar == g_hCashFlag)
	{
		GetConVarString(g_hCashFlag, g_sCashFlag, sizeof(g_sCashFlag));
	}
	else if(cvar == g_hHPFlag)
	{
		GetConVarString(g_hHPFlag, g_sHPFlag, sizeof(g_sHPFlag));
	}
	else if(cvar == g_hSpeedFlag)
	{
		GetConVarString(g_hSpeedFlag, g_sSpeedFlag, sizeof(g_sSpeedFlag));
	}
	else if(cvar == g_hGodModeFlag)
	{
		GetConVarString(g_hGodModeFlag, g_sGodModeFlag, sizeof(g_sGodModeFlag));
	}
	else if(cvar == g_hScoreFlag)
	{
		GetConVarString(g_hScoreFlag, g_sScoreFlag, sizeof(g_sScoreFlag));
	}
	else if(cvar == g_hExecFlag)
	{
		GetConVarString(g_hExecFlag, g_sExecFlag, sizeof(g_sExecFlag));
	}
	else if(cvar == g_hNoChatLogFlags)
	{
		GetConVarString(g_hNoChatLogFlags, g_sNoChatLogFlags, sizeof(g_sNoChatLogFlags));
	}
	else if(cvar == g_hModelFlag)
	{
		GetConVarString(g_hModelFlag, g_sModelFlag, sizeof(g_sModelFlag));
	}
	else if(cvar == g_hOverlayFlag)
	{
		GetConVarString(g_hOverlayFlag, g_sOverlayFlag, sizeof(g_sOverlayFlag));
	}
	else if(cvar == g_hResizeFlag)
	{
		GetConVarString(g_hResizeFlag, g_sResizeFlag, sizeof(g_sResizeFlag));
	}
	else if(cvar == g_hMapTimeFlag)
	{
		GetConVarString(g_hMapTimeFlag, g_sMapTimeFlag, sizeof(g_sMapTimeFlag));
	}
	else if(cvar == g_hAmmoFlag)
	{
		GetConVarString(g_hAmmoFlag, g_sAmmoFlag, sizeof(g_sAmmoFlag));
	}
}

public Action OnRoundStart(Event hEvent, const char[] sName, bool bDontBroadcast)
{
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i))
		{
			CreateTimer(0.5, Timer_ResetSize, i, TIMER_FLAG_NO_MAPCHANGE);
			ClientCommand(i, "r_screenoverlay \"\"");
		}
	}
}

public Action Event_WeaponFire(Event hEvent, const char[] sName, bool bDontBroadcast)
{
	int client = GetClientOfUserId(hEvent.GetInt("userid"));
	if(IsValidClient(client))
	{
		if(g_bAmmoFlag[client])
		{
			char sWeapon[64];
			hEvent.GetString("weapon", sWeapon, sizeof(sWeapon));
			if(!StrEqual(sWeapon, "knife") && !StrEqual(sWeapon, "smokegrenade") && !StrEqual(sWeapon, "hegrenade") && !StrEqual(sWeapon, "flashbang") && !StrEqual(sWeapon, "c4"))
			{
				int iWeapon = GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon");
				SetEntProp(iWeapon, Prop_Send, "m_iClip1", 100);
				SetEntProp(iWeapon, Prop_Send, "m_iClip2", 100);
			}
		}
	}

	return Plugin_Changed;
}

public Action Timer_ResetSize(Handle timer, any client)
{
	ResizePlayer(client, "1.0");
}

public void OnClientConnected(int client)
{
	g_iDisableTP[client] = 0;
	g_iGodMode[client] = 0;
	g_bAmmoFlag[client] = false;
}

public void OnClientDisconnect(int client)
{
	g_iDisableTP[client] = 0;
	g_iGodMode[client] = 0;
	ClientCommand(client, "r_screenoverlay \"\"");
	g_bAmmoFlag[client] = false;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////// COMMANDS //////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

public Action Command_MapTime(int client, int iArgs)
{
	if(iArgs != 1)
	{
		ReplyToCommand(client, "%sUsage: sm_maptime <value>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sMapTimeFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sNewTime[65];
	int iNewTime, iOldTime, iOldTimeLeft, iNewTimeLeft;
	
	GetCmdArg(1, sNewTime, sizeof(sNewTime));
	iNewTime = StringToInt(sNewTime);
	
	GetMapTimeLimit(iOldTime);
	iOldTime = RoundToCeil(float(iOldTime)/60);
	
	GetMapTimeLeft(iOldTimeLeft);
	iOldTimeLeft = RoundToCeil(float(iOldTimeLeft)/60);

	g_hTimelimit = FindConVar("mp_timelimit");
	SetConVarInt(g_hTimelimit, iNewTime);

	GetMapTimeLeft(iNewTimeLeft);
	iNewTimeLeft = RoundToCeil(float(iNewTimeLeft)/60);
	
	if(!HasOneFlag(client, g_sNoChatLogFlags))
	{
		PrintToChatAll("\x04%s%N \x03changed total map time from %i to %i! Map time remaining changed from %i to %i.", TAG, client, iOldTime, iNewTime, iOldTimeLeft, iNewTimeLeft);
	}
	else
	{
		ReplyToCommand(client, "%sTotal map time changed from %i to %i minutes! Map time remaining changed from %i to %i.", TAG, iOldTime, iNewTime, iOldTimeLeft, iNewTimeLeft);
	}
	
	LogToGame("%L changed total map time from %i to %i! Map time remaining changed from %i to %i.", client, iOldTime, iNewTime, iOldTimeLeft, iNewTimeLeft);
	LogAction(client, client, "%L changed total map time from %i to %i! Map time remaining changed from %i to %i.", client, iOldTime, iNewTime, iOldTimeLeft, iNewTimeLeft);
	
	return Plugin_Handled;
}

public Action Command_ExtendMapTime(int client, int iArgs)
{
	if(iArgs != 1)
	{
		ReplyToCommand(client, "%sUsage: sm_extendmap <minutes>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sMapTimeFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sTime[65];
	int iTime, iOldTimeLeft, iNewTimeLeft;
	GetCmdArg(1, sTime, sizeof(sTime));
	iTime = StringToInt(sTime);
	
	GetMapTimeLeft(iOldTimeLeft);
	iOldTimeLeft = RoundToCeil(float(iOldTimeLeft)/60);

	ExtendMapTimeLimit(iTime*60);
	
	GetMapTimeLeft(iNewTimeLeft);
	iNewTimeLeft = RoundToCeil(float(iNewTimeLeft)/60);
	
	if(!HasOneFlag(client, g_sNoChatLogFlags))
	{
		PrintToChatAll("\x04%s%N \x03extended map time by %i minutes! Map time remaining changed from %i to %i.", TAG, client, iTime, iOldTimeLeft, iNewTimeLeft);
	}
	LogToGame("%L extended map time by %i minutes! Map time remaining changed from %i to %i.", client, iTime, iOldTimeLeft, iNewTimeLeft);
	LogAction(client, client, "%L extended map time by %i minutes! Map time remaining changed from %i to %i.", client, iTime, iOldTimeLeft, iNewTimeLeft);
	
	return Plugin_Handled;
}

public Action Command_Resize(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_resize <target> <size multiplier>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sResizeFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sArg[65], sSize[128];
	GetCmdArg(1, sArg, sizeof(sArg));
	GetCmdArg(2, sSize, sizeof(sSize));

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sArg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}
	
	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			ResizePlayer(target, sSize);
			if(!HasOneFlag(client, g_sNoChatLogFlags))
			{
				PrintToChatAll("\x04%s%N \x03resized player \x04%N\x03 to %s times their size!", TAG, client, target, sSize);
			}
			LogToGame("%L resized %L to %s times their size.", client, target, sSize);
			LogAction(client, target, "%L resized %L to %s times their size.", client, target, sSize);
		}
	}
	
	return Plugin_Handled;
}

bool ResizePlayer(const int client, const char[] szScale)
{
	float fScale = StringToFloat(szScale);
	if(IsValidEntity(client))
	{
		SetEntPropFloat(client, Prop_Send, "m_flModelScale", fScale);

		if(g_bHitboxAvailable)
		{
			UpdatePlayerHitbox(client);
		}
	}
	return true;
}

stock void UpdatePlayerHitbox(const int client)
{
	static const float vecGenericPlayerMin[3] = { -16.5, -16.5, 0.0 }, vecGenericPlayerMax[3] = { 16.5,  16.5, 73.0 };
	float vecScaledPlayerMin[3], vecScaledPlayerMax[3];

	vecScaledPlayerMin = vecGenericPlayerMin;
	vecScaledPlayerMax = vecGenericPlayerMax;

	ScaleVector(vecScaledPlayerMin, 1.0);
	ScaleVector(vecScaledPlayerMax, 1.0);
	SetEntPropVector(client, Prop_Send, "m_vecSpecifiedSurroundingMins", vecScaledPlayerMin);
	SetEntPropVector(client, Prop_Send, "m_vecSpecifiedSurroundingMaxs", vecScaledPlayerMax);
}

public Action Command_SetEntModel(int client, int iArgs)
{
	if(!HasFlags(client, g_sModelFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	if(IsValidClient(client))
	{
		int iEntID = GetClientAimTarget(client, false);
		if(iEntID != -1)
		{
			if(!IsValidClient(iEntID))
			{
				if(IsValidEntity(iEntID))
				{
					char sModel[256];
					GetCmdArgString(sModel, sizeof(sModel));
					if(IsModelPrecached(sModel))
					{
						SetEntityModel(iEntID, sModel);
						ReplyToCommand(client, "\x03%sSuccessfully set target model!", TAG);
					}
					else
					{
						ReplyToCommand(client, "\x03%sModel has not been precached!", TAG);
					}
				}
			}
			else
			{
				ReplyToCommand(client, "\x03%sYou cannot use this command on players.", TAG);
			}
		}
		else
		{
			ReplyToCommand(client, "\x03%sNo entities found at crosshair aim.", TAG);
		}
	}
	else
	{
		ReplyToCommand(client, "%sYou must be in the server to use this command!", TAG);
	}

	return Plugin_Handled;
}

public Action Command_ResizeEnt(int client, int iArgs)
{
	if(iArgs != 1)
	{
		ReplyToCommand(client, "%sUsage: sm_resizeent <size multiplier> (target with crosshairs)", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sResizeFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	if(IsValidClient(client))
	{
		int iEntID = GetClientAimTarget(client, false);
		if(iEntID != -1)
		{
			if(!IsValidClient(iEntID))
			{
				if(GetEntPropFloat(iEntID, Prop_Send, "m_flModelScale"))
				{
					char sSize[20];
					GetCmdArg(1,sSize,sizeof(sSize));
					ResizeEnt(iEntID, sSize);
					if(!HasOneFlag(client, g_sNoChatLogFlags))
					{
						PrintToChatAll("\x04%s%N \x03resized an entity to %s times its size!", TAG, client, sSize);
					}
					LogToGame("%L resized an entity to %s times its size!", client, sSize);
					LogAction(client, client, "%L resized an entity to %s times its size!", client, sSize);
				}
				else
				{
					ReplyToCommand(client, "\x03%s Not a valid entity.", TAG);
				}
			}
			else
			{
				ReplyToCommand(client, "\x03%sYou cannot use this command on players.", TAG);
			}
		}
		else
		{
			ReplyToCommand(client, "\x03%sNo entities found at crosshair aim.", TAG);
		}
	}
	else
	{
		ReplyToCommand(client, "%sYou must be in the server to use this command!", TAG);
	}

	return Plugin_Handled;
}

void ResizeEnt(int iEntID, char[] sToSize)
{
	float fScale = StringToFloat(sToSize);
	SetEntPropFloat(iEntID, Prop_Send, "m_flModelScale", fScale);
}

public Action Command_ForceModel(int client, int iArgs)
{
	if(IsValidClient(client))
	{
		if(HasFlags(client, g_sModelFlag))
		{
			char arg[65];
			GetCmdArg(1, arg, sizeof(arg));

			char target_name[MAX_TARGET_LENGTH];
			int target_list[MAXPLAYERS], target_count;
			bool tn_is_ml;

			if((target_count = ProcessTargetString(arg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, target_name, sizeof(target_name), tn_is_ml)) <= 0)
			{
				PrintToConsole(client, "Not found or invalid parameter.");
				return Plugin_Handled;
			}
			
			char model[65];
			GetCmdArg(2, model, sizeof(model));
			
			if(StrEqual(model, "turtle", false))
			{
				Format(model, sizeof(model), "models/props/de_tides/vending_turtle.mdl");
			}
			else if(StrEqual(model, "banana", false))
			{
				Format(model, sizeof(model), "models/props/cs_italy/bananna.mdl");
			}
			else if(StrEqual(model, "milk", false))
			{
				Format(model, sizeof(model), "models/props_junk/garbage_milkcarton002a.mdl");
			}
			else if(StrEqual(model, "tire", false))
			{
				Format(model, sizeof(model), "models/props_vehicles/tire001c_car.mdl");
			}

			if(IsModelPrecached(model))
			{
				for (int i = 0; i < target_count; i++)
				{
					int target = target_list[i];
					if(IsValidClient(target))
					{
						if(IsPlayerAlive(target))
						{
							SetEntityModel(target, model);
						}
					}
				}
				ReplyToCommand(client, "\x03%sSuccessfully set targets models!", TAG);
			}
			else
			{
				ReplyToCommand(client, "\x03%sModel has not been precached!", TAG);
			}
			
		}
		else
		{
			PrintToChat(client, "You do not have access to this command!");
		}
	}
	else
	{
		
		char arg[65];
		GetCmdArg(1, arg, sizeof(arg));

		char target_name[MAX_TARGET_LENGTH];
		int target_list[MAXPLAYERS], target_count;
		bool tn_is_ml;

		if((target_count = ProcessTargetString(arg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, target_name, sizeof(target_name), tn_is_ml)) <= 0)
		{
			PrintToConsole(client, "Not found or invalid parameter.");
			return Plugin_Handled;
		}
		
		char model[65];
		GetCmdArg(2, model, sizeof(model));
		
		if(IsModelPrecached(model))
		{
			for (int i = 0; i < target_count; i++)
			{
				int target = target_list[i];
				if(IsValidClient(target))
				{
					if(IsPlayerAlive(target))
					{
						SetEntityModel(target, model);
					}
				}
			}
			ReplyToCommand(client, "\x03%sSuccessfully set targets models!", TAG);
		}
		else
		{
			ReplyToCommand(client, "\x03%sModel has not been precached!", TAG);
		}
	}
	return Plugin_Handled;
}

public Action Command_Respawn(int client, int iArgs)
{
	if(iArgs != 1)
	{
		ReplyToCommand(client, "%sUsage: sm_respawn <target>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sRespawnFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sArg[65];
	GetCmdArg(1, sArg, sizeof(sArg));

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sArg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}
	
	bool bValidTarget = false;
	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			if(!IsPlayerAlive(target) && ((GetClientTeam(target) == 2) || (GetClientTeam(target) == 3)))
			{
				bValidTarget = true;
				CS_RespawnPlayer(target);
				if(!HasOneFlag(client, g_sNoChatLogFlags))
				{
					PrintToChatAll("\x04%s%N \x03has been respawned by \x04%N", TAG, target, client);
				}
				LogToGame("%L has been respawned by %L", target, client);
				LogAction(client, target, "%L has been respawned by %L", target, client);
			}
		}
	}
	
	if(!bValidTarget)	//added in case target string is valid, but then all targets are filtered by "IsPlayerAlive"
	{
		ReplyToCommand(client, "\x04%sAll targets are either invalid or not alive.", TAG);
	}
	
	return Plugin_Handled;
}

public Action Command_GetModel(int client, int iArgs)
{
	if(IsValidClient(client))
	{
		int iEntID = GetClientAimTarget(client, false);
		if(iEntID != -1)
		{
			char sMdl[PLATFORM_MAX_PATH];
			GetEntPropString(iEntID, Prop_Data, "m_ModelName", sMdl, sizeof(sMdl)); 
			ReplyToCommand(client, "%sModel path: %s", TAG, sMdl);
		}
		else
		{
			ReplyToCommand(client, "%sNo valid entities found at crosshair aim.", TAG);
		}
	}
	else
	{
		ReplyToCommand(client, "%sYou must be in the server to use this command!", TAG);
	}
	return Plugin_Handled;
}

public Action Command_FExec(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_fexec <target> <action in quotes>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sExecFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sArg[65], sCmd[128];
	GetCmdArg(1, sArg, sizeof(sArg));
	GetCmdArg(2, sCmd, sizeof(sCmd));

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sArg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}
	
	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			FakeClientCommandEx(target, sCmd);
			if(!HasOneFlag(client, g_sNoChatLogFlags))
			{
				PrintToChatAll("\x04%s%N \x03executed a fake command on \x04%N", TAG, client, target);
			}
			LogToGame("%L executed a fake command on %L", client, target);
			LogAction(client, target, "%L executed a fake command on %L", client, target);
		}
	}
	
	return Plugin_Handled;
}

public Action Command_CExec(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_cexec <target> <action in quotes>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sExecFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sArg[65], sCmd[128];
	GetCmdArg(1, sArg, sizeof(sArg));
	GetCmdArg(2, sCmd, sizeof(sCmd));

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sArg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}
	
	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			ClientCommand(target, sCmd);
			if(!HasOneFlag(client, g_sNoChatLogFlags))
			{
				PrintToChatAll("\x04%s%N \x03executed a client command on \x04%N", TAG, client, target);
			}
			LogToGame("%L executed a client command on %L", client, target);
			LogAction(client, target, "%L executed a client command on %L", client, target);
		}
	}
	
	return Plugin_Handled;
}

public Action Command_Knife(int client, int iArgs)
{
	if(iArgs != 1)
	{
		ReplyToCommand(client, "%sUsage: sm_knife <target>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sKnifeFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sArg[65];
	GetCmdArg(1, sArg, sizeof(sArg));

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sArg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}
	
	bool bValidTarget = false;
	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			if(IsPlayerAlive(target))
			{
				bValidTarget = true;
				Handle data = CreateDataPack();
				WritePackCell(data, target);
				WritePackString(data, "weapon_knife");
				ResetPack(data);
				CreateTimer(0.1, GiveItem, data);
				if(!HasOneFlag(client, g_sNoChatLogFlags))
				{
					PrintToChatAll("\x04%s%N \x03has been given a knife by \x04%N", TAG, target, client);
				}
				LogToGame("%L has been given a knife by %L", target, client);
				LogAction(client, target, "%L has been given a knife by %L", target, client);
			}
		}
	}
	
	if(!bValidTarget)	//added in case target string is valid, but then all targets are filtered by "IsPlayerAlive"
	{
		ReplyToCommand(client, "\x04%sAll targets are either invalid or not alive.", TAG);
	}
	
	return Plugin_Handled;
}

public Action Command_Weapon(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_weapon <target> <weapon>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sWeaponFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sItemString[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	GetCmdArg(2, sItemString, sizeof(sItemString));
	Format(sItemString, sizeof(sItemString), "weapon_%s", sItemString);

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}
	
	bool bValidTarget = false;
	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			if(IsPlayerAlive(target))
			{
				bValidTarget = true;
				Handle data = CreateDataPack();
				WritePackCell(data, target);
				WritePackString(data, sItemString);
				ResetPack(data);
				CreateTimer(0.1, GiveItem, data);
				if(!HasOneFlag(client, g_sNoChatLogFlags))
				{
					PrintToChatAll("\x04%s%N \x03has been given item %s by \x04%N", TAG, target, sItemString, client);
				}
				LogToGame("%L has been given item %s by %L", target, sItemString, client);
				LogAction(client, target, "%L has been given item %s by %L", target, sItemString, client);
			}
		}
	}
	
	if(!bValidTarget)	//added in case target string is valid, but then all targets are filtered by "IsPlayerAlive"
	{
		ReplyToCommand(client, "\x04%sAll targets are either invalid or not alive.", TAG);
	}
	
	return Plugin_Handled;
}

public Action Command_Cash(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_cash <target> <amount>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sCashFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sValue[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	GetCmdArg(2, sValue, sizeof(sValue));

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			int iValue = StringToInt(sValue) + GetEntProp(target, Prop_Send, "m_iAccount");
			SetEntProp(target, Prop_Send, "m_iAccount", iValue);
			if(!HasOneFlag(client, g_sNoChatLogFlags))
			{
				PrintToChatAll("\x04%s%N \x03has been given %s cash by \x04%N", TAG, target, sValue, client);
			}
			LogToGame("%L has been given %s cash by %L", target, sValue, client);
			LogAction(client, target, "%L has been given %s cash by %L", target, sValue, client);
		}
	}
	
	return Plugin_Handled;
}

public Action Command_SetCash(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_setcash <target> <amount>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sCashFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sValue[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	GetCmdArg(2, sValue, sizeof(sValue));
	int iValue = StringToInt(sValue);

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			SetEntProp(target, Prop_Send, "m_iAccount", iValue);
			if(!HasOneFlag(client, g_sNoChatLogFlags))
			{
				PrintToChatAll("\x04%s%N \x03had their cash set to %i by \x04%N", TAG, target, iValue, client);
			}
			LogToGame("%L had their cash set to %i by %L", target, iValue, client);
			LogAction(client, target, "%L had their cash set to %i by %L", target, iValue, client);
		}
	}
	
	return Plugin_Handled;
}

public Action Command_SetPropFloat(int client, int iArgs)
{
	if(iArgs != 3)
	{
		ReplyToCommand(client, "%sUsage: sm_setpropfloat target \"property\" \"value\"", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sModelFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sProperty[MAX_NAME_LENGTH], sValue[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	GetCmdArg(2, sProperty, sizeof(sProperty));
	GetCmdArg(3, sValue, sizeof(sValue));
	float fValue = StringToFloat(sValue);

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			SetEntPropFloat(target, Prop_Send, sProperty, fValue);
		}
	}
	
	return Plugin_Handled;
}

public Action Command_SetPropInt(int client, int iArgs)
{
	if(iArgs != 3)
	{
		ReplyToCommand(client, "%sUsage: sm_setpropfloat target \"property\" \"value\"", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sModelFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sProperty[MAX_NAME_LENGTH], sValue[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	GetCmdArg(2, sProperty, sizeof(sProperty));
	GetCmdArg(3, sValue, sizeof(sValue));
	int iValue = StringToInt(sValue);

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			SetEntProp(target, Prop_Send, sProperty, iValue);
		}
	}
	
	return Plugin_Handled;
}

public Action Command_GodMode(int client, int iArgs)
{
	if(iArgs != 1)
	{
		ReplyToCommand(client, "%sUsage: sm_gm <target>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sGodModeFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			int iMode;
			if(g_iGodMode[target] == 1) //if already on
			{
				g_iGodMode[target] = 0;
				iMode = 2;
			}
			else //else turn on
			{
				g_iGodMode[target] = 1;
				iMode = 2;
			}
			SetEntProp(target, Prop_Data, "m_takedamage", iMode);
			if(g_iGodMode[target])
			{
				if(!HasOneFlag(client, g_sNoChatLogFlags))
				{
					PrintToChatAll("\x04%s%N \x03was given god mode by \x04%N", TAG, target, client);
				}
				LogToGame("%L was given god mode by %L", target, client);
				LogAction(client, target, "%L was given god mode by %L", target, client);
			}
			else
			{
				if(!HasOneFlag(client, g_sNoChatLogFlags))
				{
					PrintToChatAll("\x04%s%N \x03had god mode removed by \x04%N", TAG, target, client);
				}
				LogToGame("%L had god mode removed by %L", target, client);
				LogAction(client, target, "%L had god mode removed by %L", target, client);
			}
		}
	}
	
	return Plugin_Handled;
}

public Action Command_Frags(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_frags <target> <value>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sScoreFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sValue[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	GetCmdArg(2, sValue, sizeof(sValue));
	int iValue = StringToInt(sValue);

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			SetEntProp(target, Prop_Data, "m_iFrags", iValue);
			if(!HasOneFlag(client, g_sNoChatLogFlags))
			{
				PrintToChatAll("\x04%s%N \x03was set to %i frags by \x04%N", TAG, target, iValue, client);
			}
			LogToGame("%L was set to %i frags by %L", target, iValue, client);
			LogAction(client, target, "%L was set to %i frags by %L", target, iValue, client);
		}
	}
	
	return Plugin_Handled;
}

public Action Command_Deaths(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_deaths <target> <value>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sScoreFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sValue[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	GetCmdArg(2, sValue, sizeof(sValue));
	int iValue = StringToInt(sValue);

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			SetEntProp(target, Prop_Data, "m_iDeaths", iValue);
			if(!HasOneFlag(client, g_sNoChatLogFlags))
			{
				PrintToChatAll("\x04%s%N \x03was set to %i deaths by \x04%N", TAG, target, iValue, client);
			}
			LogToGame("%L was set to %i deaths by %L", target, iValue, client);
			LogAction(client, target, "%L was set to %i deaths by %L", target, iValue, client);
		}
	}
	
	return Plugin_Handled;
}

public Action Command_SetHP(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_hp <target> <amount>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sHPFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sValue[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	GetCmdArg(2, sValue, sizeof(sValue));
	int iValue = StringToInt(sValue);

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			SetEntProp(target, Prop_Send, "m_iHealth", iValue);
			if(!HasOneFlag(client, g_sNoChatLogFlags))
			{
				PrintToChatAll("\x04%s%N \x03had their hp set to %i by \x04%N", TAG, target, iValue, client);
			}
			LogToGame("%L had their hp set to %i by %L", target, iValue, client);
			LogAction(client, target, "%L had their hp set to %i by %L", target, iValue, client);
		}
	}
	
	return Plugin_Handled;
}

public Action Command_Overlay(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_overlay <target> <path>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sOverlayFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sPath[PLATFORM_MAX_PATH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	GetCmdArg(2, sPath, sizeof(sPath));

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			ShowOverlay(target, sPath);
			if(!HasOneFlag(client, g_sNoChatLogFlags))
			{
				PrintToChatAll("\x04%s%N \x03had an their overlay forced by \x04%N", TAG, target, client);
			}
			LogToGame("%L had an their overlay forced by %L", target, client);
			LogAction(client, target, "%L had an their overlay forced by %L", target, client);
		}
	}
	
	return Plugin_Handled;
}

void ShowOverlay(int client, char[] sPath)
{
	if(g_bCSGO)
	{
		int iSprite = CreateEntityByName("env_sprite"); 
		if(iSprite != -1) 
		{ 
			float a_fPos[3]; 
			GetEntPropVector(iSprite, Prop_Send, "m_vecOrigin", a_fPos);
			DispatchKeyValueVector(iSprite, "origin", a_fPos);
			DispatchKeyValue(iSprite, "spawnflags", "0");
			DispatchKeyValue(iSprite, "scale", "0.5");
			DispatchKeyValue(iSprite, "rendermode", "5");
			DispatchKeyValue(iSprite, "rendercolor", "255 255 255");
			DispatchKeyValue(iSprite, "renderamt", "255");
			DispatchKeyValue(iSprite, "model", "filename.vmt");
			DispatchSpawn(iSprite);
			AcceptEntityInput(iSprite, "ShowSprite");

			SetVariantString("!activator"); 
			AcceptEntityInput(iSprite, "SetParent", client); 

			char sAddOutput[100] ;
			Format(sAddOutput, sizeof(sAddOutput), "OnUser1 !self:kill::%0.2f:-1", 5.0); 
			SetVariantString(sAddOutput); 
			AcceptEntityInput(iSprite, "AddOutput"); 
			AcceptEntityInput(iSprite, "FireUser1"); 
		} 
	}
	else
	{
		ClientCommand(client, "r_screenoverlay \"%s\"", sPath);
	}
}

public Action Command_Speed(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_speed <target> <multiplier>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sSpeedFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetString[MAX_NAME_LENGTH], sValue[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetString, sizeof(sTargetString));
	GetCmdArg(2, sValue, sizeof(sValue));
	float fValue = StringToFloat(sValue);

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sTargetString, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			SetEntPropFloat(target, Prop_Send, "m_flLaggedMovementValue", fValue);
			if(!HasOneFlag(client, g_sNoChatLogFlags))
			{
				PrintToChatAll("\x04%s%N \x03had their speed multiplied by %f by \x04%N", TAG, target, fValue, client);
			}
			LogToGame("%L had their speed multiplied by %f by %L", target, fValue, client);
			LogAction(client, target, "%L had their speed multiplied by %f by %L", target, fValue, client);
		}
	}
	
	return Plugin_Handled;
}

public Action Command_TP(int client, int iArgs)
{
	if(iArgs != 1)
	{
		ReplyToCommand(client, "%sUsage: sm_tp <target>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sTeleportFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sArg[65];
	GetCmdArg(1, sArg, sizeof(sArg));

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sArg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}

	Handle hTraceRay;
	float faStartOrigin[3], faAngles[3];

	//Initialize:
	GetClientEyeAngles(client, faAngles);
	GetClientEyePosition(client, faStartOrigin);

	//Ray:
	hTraceRay = TR_TraceRayEx(faStartOrigin, faAngles, MASK_SHOT, RayType_Infinite);

	//Collision:
	if(TR_DidHit(hTraceRay))
	{
		float fDistance;
		float faPositionBuffer[3], faEndOrigin[3], faCeilingBuffer[3];

		TR_GetEndPosition(faEndOrigin, hTraceRay);

		fDistance = (GetVectorDistance(faStartOrigin, faEndOrigin) - 35.0);

		faPositionBuffer[2] = faEndOrigin[2];
		faPositionBuffer[1] = (faStartOrigin[1] + (fDistance * Sine(DegToRad(faAngles[1]))));
		faPositionBuffer[0] = (faStartOrigin[0] + (fDistance * Cosine(DegToRad(faAngles[1]))));

		faCeilingBuffer = faPositionBuffer;
		faCeilingBuffer[2] = (faCeilingBuffer[2] - 90.0);

		if(TR_GetPointContents(faCeilingBuffer) == 0)
		{
			faPositionBuffer[2] = (faPositionBuffer[2] - 90.0);
		}

		bool bValidTarget = false;
		for (int i = 0; i < target_count; i++)
		{
			int target = target_list[i];
			if(IsValidClient(target))
			{
				if(IsPlayerAlive(target))
				{
					bValidTarget = true;
					TeleportEntity(target, faPositionBuffer, NULL_VECTOR, NULL_VECTOR);
					if(!HasOneFlag(client, g_sNoChatLogFlags))
					{
						PrintToChatAll("\x04%s%N \x01teleported \x04%N", TAG, client, target);
					}
					LogToGame("%L teleported %L", client, target);
					LogAction(client, target, "%L teleported %L", client, target);
				}
			}
		}
		
		if(!bValidTarget)	//added in case target string is valid, but then all targets are filtered by "IsPlayerAlive"
		{
			ReplyToCommand(client, "\x04%sAll targets are either invalid or not alive.", TAG);
		}
	}
	else
	{
		ReplyToCommand(client, "%sCrosshairs do not hit anything!", TAG);
	}
	
	//End:
	CloseHandle(hTraceRay);
	
	return Plugin_Handled;
}


public Action Command_Bring(int client, int iArgs)
{
	if(iArgs != 1)
	{
		ReplyToCommand(client, "%sUsage: sm_bring <target>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sTeleportFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sArg[65];
	GetCmdArg(1, sArg, sizeof(sArg));

	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sArg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}
	
	bool bValidTarget = false;
	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			if(IsPlayerAlive(target))
			{
				bValidTarget = true;
				PerformTeleport(target, client);
				if(!HasOneFlag(client, g_sNoChatLogFlags))
				{
					PrintToChatAll("\x04%s%N \x01teleported \x04%N  to themself", TAG, client, target);
				}
				LogToGame("%L teleported %L to themself", client, target);
				LogAction(client, target, "%L teleported %L to themself", client, target);
			}
		}
	}
	
	if(!bValidTarget)	//added in case target string is valid, but then all targets are filtered by "IsPlayerAlive"
	{
		ReplyToCommand(client, "\x04%sAll targets are either invalid or not alive.", TAG);
	}

	return Plugin_Handled;
}

public Action Command_OBring(int client, int iArgs)
{
	if(iArgs != 1)
	{
		ReplyToCommand(client, "%sUsage: sm_obring <target>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sTeleportFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char arg[65];
	GetCmdArg(1, arg, sizeof(arg));

	char target_name[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(arg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, target_name, sizeof(target_name), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}
	
	bool bValidTarget = false;
	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			if(IsPlayerAlive(target) && !g_iDisableTP[target])
			{
				bValidTarget = true;
				PerformTeleport(target, client);
				if(!HasOneFlag(client, g_sNoChatLogFlags))
				{
					PrintToChatAll("\x04%s%N \x01teleported \x04%N  to themself", TAG, client, target);
				}
				LogMessage("%L teleported %L to themself", client, target);
				LogToGame("%L teleported %L to themself", client, target);
			}
		}
	}
	
	if(!bValidTarget)	//added in case target string is valid, but then all targets are filtered by "IsPlayerAlive" or tpdisable
	{
		ReplyToCommand(client, "\x04%sAll targets are either invalid or not alive.", TAG);
	}

	return Plugin_Handled;
}

public Action Command_DisableTP(int client, int iArgs)
{
	if(IsValidClient(client))
	{
		g_iDisableTP[client] = 1;
		PrintToChat(client, "$sx04You will not be teleported by the sm_cbring command for the rest of this map.", TAG);
	}
	return Plugin_Handled;
}

public Action Command_EnableTP(int client, int iArgs)
{
	if(IsValidClient(client))
	{
		g_iDisableTP[client] = 0;
		PrintToChat(client, "%sx04You will now be teleported by the sm_cbring command.", TAG);
	}
	return Plugin_Handled;
}

public Action Command_Goto(int client, int iArgs)
{
	if(iArgs != 1)
	{
		ReplyToCommand(client, "%sUsage: sm_goto <target>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sTeleportFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}
	
	char sTargetName[MAX_NAME_LENGTH];
	GetCmdArg(1, sTargetName, sizeof(sTargetName));

	if(SearchForPlayer(sTargetName) == 0)
	{
		ReplyToCommand(client, "%sThere are no players matching your argument!", TAG);
		return Plugin_Handled;
	}
	else if(SearchForPlayer(sTargetName) > 1)
	{
		ReplyToCommand(client, "%sThere is more than one player matching your argument!", TAG);
		return Plugin_Handled;
	}
	
	int target = FindTarget(client, sTargetName, false, false);
	if(target == -1)
	{
		ReplyToCommand(client, "%sInvalid target!", TAG);
		return Plugin_Handled;
	}
	
	PerformTeleport(client, target);	
	if(!HasOneFlag(client, g_sNoChatLogFlags))
	{
		PrintToChatAll("\x04%s%N \x01teleported to \x04%N", TAG, client, target);
	}
	LogToGame("%L teleported to %L", client, target);
	LogAction(client, target, "%L teleported to %L", client, target);
	
	return Plugin_Handled;
}

public Action Command_Send(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_send <send target> <to target>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sTeleportFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sendArg[64], toArg[64];
	GetCmdArg(1, sendArg, sizeof(sendArg));
	GetCmdArg(2, toArg, sizeof(toArg));
	
	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sendArg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}
	
	if(SearchForPlayer(toArg) == 0)
	{
		ReplyToCommand(client, "%sThere are no players matching your argument!", TAG);
		return Plugin_Handled;
	}
	else if(SearchForPlayer(toArg) > 1)
	{
		ReplyToCommand(client, "%sThere is more than one player matching your argument!", TAG);
		return Plugin_Handled;
	}
	
	int toTarget = FindTarget(client, toArg, false, false);
	if(toTarget == -1)
	{
		ReplyToCommand(client, "%sInvalid target!", TAG);
		return Plugin_Handled;
	}
	
	bool bValidTarget = false;
	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			if(IsPlayerAlive(target))
			{
				bValidTarget = true;
				PerformTeleport(target, toTarget);
				if(!HasOneFlag(client, g_sNoChatLogFlags))
				{
					PrintToChatAll("\x04%s%N \x01teleported %N \x04%N", TAG, client, target, toTarget);
				}
				LogToGame("%L teleported %L to %L", client, target, toTarget);
				LogAction(client, -1, "%L teleported %L to %L", client, target, toTarget);
			}
		}
	}
	
	if(!bValidTarget)	//added in case target string is valid, but then all targets are filtered by "IsPlayerAlive"
	{
		ReplyToCommand(client, "\x04%sAll targets are either invalid or not alive.", TAG);
	}
	
	return Plugin_Handled;
}

public Action Command_OSend(int client, int iArgs)
{
	if(iArgs != 2)
	{
		ReplyToCommand(client, "%sUsage: sm_osend <send target> <to target>", TAG);
		return Plugin_Handled;
	}

	if(!HasFlags(client, g_sTeleportFlag))
	{
		ReplyToCommand(client, "%sYou do not have access to this command!", TAG);
		return Plugin_Handled;
	}

	char sendArg[64], toArg[64];
	GetCmdArg(1, sendArg, sizeof(sendArg));
	GetCmdArg(2, toArg, sizeof(toArg));
	
	char sTargetName[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS], target_count;
	bool tn_is_ml;

	if((target_count = ProcessTargetString(sendArg, client, target_list, MAXPLAYERS, COMMAND_FILTER_CONNECTED, sTargetName, sizeof(sTargetName), tn_is_ml)) <= 0)
	{
		PrintToConsole(client, "%sNot found or invalid parameter.", TAG);
		return Plugin_Handled;
	}
	
	if(SearchForPlayer(toArg) == 0)
	{
		ReplyToCommand(client, "%sThere are no players matching your argument!", TAG);
		return Plugin_Handled;
	}
	else if(SearchForPlayer(toArg) > 1)
	{
		ReplyToCommand(client, "%sThere is more than one player matching your argument!", TAG);
		return Plugin_Handled;
	}
	
	int toTarget = FindTarget(client, toArg, false, false);
	if(toTarget == -1)
	{
		ReplyToCommand(client, "%sInvalid target!", TAG);
		return Plugin_Handled;
	}
	
	bool bValidTarget = false;
	for (int i = 0; i < target_count; i++)
	{
		int target = target_list[i];
		if(IsValidClient(target))
		{
			if(IsPlayerAlive(target) && !g_iDisableTP[target])
			{
				bValidTarget = true;
				PerformTeleport(target, toTarget);
				if(!HasOneFlag(client, g_sNoChatLogFlags))
				{
					PrintToChatAll("\x04%s%N \x01teleported %N \x04%N", TAG, client, target, toTarget);
				}
				LogToGame("%L teleported %L to %L", client, target, toTarget);
				LogAction(client, -1, "%L teleported %L to %L", client, target, toTarget);
			}
		}
	}
	
	if(!bValidTarget)	//added in case target string is valid, but then all targets are filtered by "IsPlayerAlive"
	{
		ReplyToCommand(client, "\x04%sAll targets are either invalid, have tp disabled, or are not alive.", TAG);
	}
	
	return Plugin_Handled;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////// MODULES ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

public Action GiveItem(Handle hTimer, any data)
{
	char sItem[100];
	int client = ReadPackCell(data);
	ReadPackString(data, sItem, sizeof(sItem));
	if(IsValidClient(client))
	{
		GivePlayerItem(client, sItem);
	}
	CloseHandle(data);
}

public void PerformTeleport(int sentClient, int toClient)
{
	float faTeleportLocation[3];	
	GetClientAbsOrigin(toClient, faTeleportLocation);	
	
	faTeleportLocation[2] = faTeleportLocation[2] + 16;
	TeleportEntity(sentClient, faTeleportLocation, NULL_VECTOR, NULL_VECTOR);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////// ADMIN MENU /////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

public void OnAdminMenuReady(Handle hTopMenu)
{
	if(g_hAdminMenu != hTopMenu)
	{
		g_hAdminMenu = hTopMenu;
		
		TopMenuObject MenuObject = AddToTopMenu(g_hAdminMenu, "togextadm", TopMenuObject_Category, Handle_Commands, INVALID_TOPMENUOBJECT);
		if(MenuObject == INVALID_TOPMENUOBJECT)
		{
			return;
		}
		
		//Adminmenu_Player1
		AddToTopMenu(g_hAdminMenu, "sm_bring", TopMenuObject_Item, Adminmenu_Player1, MenuObject, "sm_bring", ADMFLAG_GENERIC, "Bring Player");
		AddToTopMenu(g_hAdminMenu, "sm_obring", TopMenuObject_Item, Adminmenu_Player1, MenuObject, "sm_obring", ADMFLAG_GENERIC, "Option-Bring Player");
		AddToTopMenu(g_hAdminMenu, "sm_goto", TopMenuObject_Item, Adminmenu_Player1, MenuObject, "sm_goto", ADMFLAG_GENERIC, "Goto Player");
		AddToTopMenu(g_hAdminMenu, "sm_tp", TopMenuObject_Item, Adminmenu_Player1, MenuObject, "sm_tp", ADMFLAG_GENERIC, "TP Player");
		AddToTopMenu(g_hAdminMenu, "sm_knife", TopMenuObject_Item, Adminmenu_Player1, MenuObject, "sm_knife", ADMFLAG_GENERIC, "Give Knives");
		AddToTopMenu(g_hAdminMenu, "sm_respawn", TopMenuObject_Item, Adminmenu_Player1, MenuObject, "sm_respawn", ADMFLAG_GENERIC, "Respawn");
		AddToTopMenu(g_hAdminMenu, "sm_gm", TopMenuObject_Item, Adminmenu_Player1, MenuObject, "sm_gm", ADMFLAG_GENERIC, "Toggle Player Godmode");
		
		//Adminmenu_Player2
		AddToTopMenu(g_hAdminMenu, "sm_send", TopMenuObject_Item, Adminmenu_Player2, MenuObject, "sm_send", ADMFLAG_GENERIC, "Send Player");
		AddToTopMenu(g_hAdminMenu, "sm_osend", TopMenuObject_Item, Adminmenu_Player2, MenuObject, "sm_osend", ADMFLAG_GENERIC, "Option-Send Player");
		
		//Adminmenu_PlayerProperty
		AddToTopMenu(g_hAdminMenu, "sm_cash", TopMenuObject_Item, Adminmenu_PlayerProperty, MenuObject, "sm_cash", ADMFLAG_GENERIC, "Give Player Cash");
		AddToTopMenu(g_hAdminMenu, "sm_setcash", TopMenuObject_Item, Adminmenu_PlayerProperty, MenuObject, "sm_setcash", ADMFLAG_GENERIC, "Set Player Cash");
	}
}

public int Handle_Commands(Handle menu, TopMenuAction action, TopMenuObject object_id, int param1, char[] sBuffer, int iMaxLength)
{
	switch(action)
	{
		case TopMenuAction_DisplayOption:
			Format(sBuffer, iMaxLength, "TOG Extended Admin");
		case TopMenuAction_DisplayTitle:
			Format(sBuffer, iMaxLength, "TOG Extended Admin");
	}
}
///////////////////////////////////////
public int Adminmenu_Player1(Handle hTopMenu, TopMenuAction action, TopMenuObject object_id, int client, char[] sBuffer, int iMaxLength)
{
	char sCommand[MAX_NAME_LENGTH], sTitle[128];
	GetTopMenuObjName(hTopMenu, object_id, sCommand, sizeof(sCommand));
	GetTopMenuInfoString(hTopMenu, object_id, sTitle, sizeof(sTitle));
	
	switch(action)
	{
		case(TopMenuAction_DisplayOption):
		{
			Format(sBuffer, iMaxLength, sTitle);
		}
		case(TopMenuAction_SelectOption):
		{
			Displaymenu_Player1(client, sCommand, sTitle);
		}
	}
}

public void Displaymenu_Player1(int client, char[] sCommand, char[] sTitle)
{
	Handle hMenu = CreateMenu(Commandmenu_Player1);
	SetMenuTitle(hMenu, sTitle);
	SetMenuExitBackButton(hMenu, true);
	
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i))
		{
			char sInfoBuffer[256], sName[MAX_NAME_LENGTH], sUserID[MAX_NAME_LENGTH], sDisplay[128];
			IntToString(GetClientUserId(i), sUserID, sizeof(sUserID));
			GetClientName(i, sName, sizeof(sName));
			Format(sDisplay, sizeof(sDisplay), "%s (%s)", sName, sUserID);
			Format(sInfoBuffer, sizeof(sInfoBuffer), "%s %s", sCommand, sUserID);
			AddMenuItem(hMenu, sInfoBuffer, sDisplay);
		}
	}
	
	DisplayMenu(hMenu, client, MENU_TIME_FOREVER);
}


public int Commandmenu_Player1(Handle hMenu, MenuAction Selection, int client, int param2)
{
	switch(Selection)
	{
		case(MenuAction_End):
		{
			CloseHandle(hMenu);
		}
		case(MenuAction_Cancel):
		{
			DisplayTopMenu(g_hAdminMenu, client, TopMenuPosition_LastCategory);
		}
		case(MenuAction_Select):
		{
			char sInfo[64];
			GetMenuItem(hMenu, param2, sInfo, sizeof(sInfo));
			char sTempArray[2][32];
			ExplodeString(sInfo, " ", sTempArray, sizeof(sTempArray), sizeof(sTempArray[]));

			if(!IsValidClient(GetClientOfUserId(StringToInt(sTempArray[1]))))
			{
				ReplyToCommand(client, "%sInvalid target.", TAG);
			}
			else if(!IsPlayerAlive(GetClientOfUserId(StringToInt(sTempArray[1]))))
			{
				ReplyToCommand(client, "%sPlayer no longer alive.", TAG);
			}
			else
			{
				char sCommand[300];
				Format(sCommand, sizeof(sCommand), "%s #%i", sTempArray[0], StringToInt(sTempArray[1]));
				FakeClientCommand(client, sCommand);
			}
		}
	}
}
////////////////////////////////////////
public int Adminmenu_Player2(Handle hTopMenu, TopMenuAction action, TopMenuObject object_id, int client, char[] sBuffer, int iMaxLength)
{
	char sCommand[MAX_NAME_LENGTH], sTitle[MAX_NAME_LENGTH];
	GetTopMenuObjName(hTopMenu, object_id, sCommand, sizeof(sCommand));
	GetTopMenuInfoString(hTopMenu, object_id, sTitle, sizeof(sTitle));
	
	switch(action)
	{
		case(TopMenuAction_DisplayOption):
		{
			Format(sBuffer, iMaxLength, sTitle);
		}
		case(TopMenuAction_SelectOption):
		{
			Displaymenu_Player2(client, sCommand, sTitle);
		}
	}
}

public void Displaymenu_Player2(int client, char[] sCommand, char[] sTitle)
{
	Handle hMenu = CreateMenu(Commandmenu_Player2);
	SetMenuTitle(hMenu, sTitle);
	SetMenuExitBackButton(hMenu, true);
	
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i))
		{
			char sInfoBuffer[256], sName[MAX_NAME_LENGTH], sUserID[MAX_NAME_LENGTH], sDisplay[128];
			IntToString(GetClientUserId(i), sUserID, sizeof(sUserID));
			GetClientName(i, sName, sizeof(sName));
			Format(sDisplay, sizeof(sDisplay), "%s (%s)", sName, sUserID);
			Format(sInfoBuffer, sizeof(sInfoBuffer), "%s %s", sCommand, sUserID);
			AddMenuItem(hMenu, sInfoBuffer, sDisplay);
		}
	}
	
	DisplayMenu(hMenu, client, MENU_TIME_FOREVER);
}


public int Commandmenu_Player2(Handle hMenu, MenuAction Selection, int client, int param2)
{
	switch(Selection)
	{
		case(MenuAction_End):
		{
			CloseHandle(hMenu);
		}
		case(MenuAction_Cancel):
		{
			DisplayTopMenu(g_hAdminMenu, client, TopMenuPosition_LastCategory);
		}
		case(MenuAction_Select):
		{
			char sInfo[64];
			GetMenuItem(hMenu, param2, sInfo, sizeof(sInfo));
			char sTempArray[2][32];
			ExplodeString(sInfo, " ", sTempArray, sizeof(sTempArray), sizeof(sTempArray[]));
			
			if(!IsValidClient(GetClientOfUserId(StringToInt(sTempArray[1]))))
			{
				ReplyToCommand(client, "%sInvalid target.", TAG);
			}
			else if(!IsPlayerAlive(GetClientOfUserId(StringToInt(sTempArray[1]))))
			{
				ReplyToCommand(client, "%sPlayer no longer alive.", TAG);
			}
			else
			{
				Displaymenu2_Player2(client, sTempArray[0], StringToInt(sTempArray[1]));
			}
		}
	}
}

public void Displaymenu2_Player2(int client, char[] sCommand, int target)
{
	Handle hMenu = CreateMenu(Commandmenu2_Player2);
	SetMenuTitle(hMenu, "Select player 2");
	SetMenuExitBackButton(hMenu, true);
	
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i))
		{
			char sInfoBuffer[256], sName[MAX_NAME_LENGTH], sUserID[MAX_NAME_LENGTH], sDisplay[128];
			IntToString(GetClientUserId(i), sUserID, sizeof(sUserID));
			GetClientName(i, sName, sizeof(sName));
			Format(sDisplay, sizeof(sDisplay), "%s (%s)", sName, sUserID);
			Format(sInfoBuffer, sizeof(sInfoBuffer), "%s %i %s", sCommand, target, sUserID);
			AddMenuItem(hMenu, sInfoBuffer, sDisplay);
		}
	}
	
	DisplayMenu(hMenu, client, MENU_TIME_FOREVER);
}

public int Commandmenu2_Player2(Handle hMenu, MenuAction Selection, int client, int param2)
{
	switch(Selection)
	{
		case(MenuAction_End):
		{
			CloseHandle(hMenu);
		}
		case(MenuAction_Cancel):
		{
			DisplayTopMenu(g_hAdminMenu, client, TopMenuPosition_LastCategory);
		}
		case(MenuAction_Select):
		{
			char sInfo[64];
			GetMenuItem(hMenu, param2, sInfo, sizeof(sInfo));
			char sTempArray[3][32];
			ExplodeString(sInfo, " ", sTempArray, sizeof(sTempArray), sizeof(sTempArray[]));
			
			if(!IsValidClient(GetClientOfUserId(StringToInt(sTempArray[2]))))
			{
				ReplyToCommand(client, "%sInvalid target.", TAG);
			}
			else if(!IsPlayerAlive(GetClientOfUserId(StringToInt(sTempArray[2]))))
			{
				ReplyToCommand(client, "%sPlayer no longer alive.", TAG);
			}
			else
			{
				FakeClientCommand(client, "%s #%i #%i", sTempArray[0], sTempArray[1], StringToInt(sTempArray[2]));
			}
		}
	}
}
//////////////////////////////////////////////
public int Adminmenu_PlayerProperty(Handle hTopMenu, TopMenuAction action, TopMenuObject object_id, int client, char[] sBuffer, int iMaxLength)
{
	char sCommand[MAX_NAME_LENGTH], sTitle[MAX_NAME_LENGTH];
	GetTopMenuObjName(hTopMenu, object_id, sCommand, sizeof(sCommand));
	GetTopMenuInfoString(hTopMenu, object_id, sTitle, sizeof(sTitle));
	
	switch(action)
	{
		case(TopMenuAction_DisplayOption):
		{
			Format(sBuffer, iMaxLength, sTitle);
		}
		case(TopMenuAction_SelectOption):
		{
			Displaymenu_PlayerProperty(client, sCommand, sTitle);
		}
	}
}

public void Displaymenu_PlayerProperty(int client, char[] sCommand, char[] sTitle)
{
	Handle hMenu = CreateMenu(Commandmenu_PlayerProperty);
	SetMenuTitle(hMenu, sTitle);
	SetMenuExitBackButton(hMenu, true);
	
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i))
		{
			char sInfoBuffer[256], sName[MAX_NAME_LENGTH], sUserID[MAX_NAME_LENGTH], sDisplay[128];
			IntToString(GetClientUserId(i), sUserID, sizeof(sUserID));
			GetClientName(i, sName, sizeof(sName));
			Format(sDisplay, sizeof(sDisplay), "%s (%s)", sName, sUserID);
			Format(sInfoBuffer, sizeof(sInfoBuffer), "%s %s", sCommand, sUserID);
			AddMenuItem(hMenu, sInfoBuffer, sDisplay);
		}
	}
	
	DisplayMenu(hMenu, client, MENU_TIME_FOREVER);
}


public int Commandmenu_PlayerProperty(Handle hMenu, MenuAction Selection, int client, int param2)
{
	switch(Selection)
	{
		case(MenuAction_End):
		{
			CloseHandle(hMenu);
		}
		case(MenuAction_Cancel):
		{
			DisplayTopMenu(g_hAdminMenu, client, TopMenuPosition_LastCategory);
		}
		case(MenuAction_Select):
		{
			char sInfo[64];
			GetMenuItem(hMenu, param2, sInfo, sizeof(sInfo));
			char sTempArray[2][32];
			ExplodeString(sInfo, " ", sTempArray, sizeof(sTempArray), sizeof(sTempArray[]));
			
			if(!IsValidClient(GetClientOfUserId(StringToInt(sTempArray[1]))))
			{
				ReplyToCommand(client, "%sInvalid target.", TAG);
			}
			else
			{
				if(StrEqual("sm_cash", sTempArray[0], false) || StrEqual("sm_setcash", sTempArray[0], false))
				{
					Displaymenu_Cash(client, StringToInt(sTempArray[1]), sTempArray[0]);
				}
			}
		}
	}
}

public void Displaymenu_Cash(int client, int target, char[] sCmd)
{
	Handle hMenu = CreateMenu(CashMenu);
	SetMenuTitle(hMenu, "Select amount");
	SetMenuExitBackButton(hMenu, true);
	
	char sInfoBuffer[256];
	
	Format(sInfoBuffer, sizeof(sInfoBuffer), "%i 0 %s", target, sCmd);
	AddMenuItem(hMenu, sInfoBuffer, "0");
	Format(sInfoBuffer, sizeof(sInfoBuffer), "%i 100 %s", target, sCmd);
	AddMenuItem(hMenu, sInfoBuffer, "100");
	Format(sInfoBuffer, sizeof(sInfoBuffer), "%i 500 %s", target, sCmd);
	AddMenuItem(hMenu, sInfoBuffer, "500");
	Format(sInfoBuffer, sizeof(sInfoBuffer), "%i 1000 %s", target, sCmd);
	AddMenuItem(hMenu, sInfoBuffer, "1000");
	Format(sInfoBuffer, sizeof(sInfoBuffer), "%i 3000 %s", target, sCmd);
	AddMenuItem(hMenu, sInfoBuffer, "3000");
	Format(sInfoBuffer, sizeof(sInfoBuffer), "%i 5000 %s", target, sCmd);
	AddMenuItem(hMenu, sInfoBuffer, "5000");
	Format(sInfoBuffer, sizeof(sInfoBuffer), "%i 10000 %s", target, sCmd);
	AddMenuItem(hMenu, sInfoBuffer, "10000");
	Format(sInfoBuffer, sizeof(sInfoBuffer), "%i 16000 %s", target, sCmd);
	AddMenuItem(hMenu, sInfoBuffer, "16000");
	
	DisplayMenu(hMenu, client, MENU_TIME_FOREVER);
}

public int CashMenu(Handle hMenu, MenuAction Selection, int client, int param2)
{
	switch(Selection)
	{
		case(MenuAction_End):
		{
			CloseHandle(hMenu);
		}
		case(MenuAction_Cancel):
		{
			DisplayTopMenu(g_hAdminMenu, client, TopMenuPosition_LastCategory);
		}
		case(MenuAction_Select):
		{
			char sInfo[64];
			GetMenuItem(hMenu, param2, sInfo, sizeof(sInfo));
			char sTempArray[3][32];
			ExplodeString(sInfo, " ", sTempArray, sizeof(sTempArray), sizeof(sTempArray[]));
			
			if(!IsValidClient(GetClientOfUserId(StringToInt(sTempArray[0]))))
			{
				ReplyToCommand(client, "%sTarget is no longer valid.", TAG);
			}
			else
			{
				FakeClientCommand(client, "%s #%i %i", sTempArray[2], StringToInt(sTempArray[0]), StringToInt(sTempArray[1]));
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////// MISC FUNCTIONS ///////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

public bool adminfilter(const char[] pattern, Handle clients)
{
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i) && CheckCommandAccess(i, "sm_admin", ADMFLAG_GENERIC, true))
		{
			PushArrayCell(clients, i);
		}
	}

	return true;
}

public bool nonadminfilter(const char[] pattern, Handle clients)
{
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i) && !CheckCommandAccess(i, "sm_admin", ADMFLAG_GENERIC, true))
		{
			PushArrayCell(clients, i);
		}
	}

	return true;
}

bool IsValidClient(int client, bool bAllowBots = false, bool bAllowDead = true)
{
	if(!(1 <= client <= MaxClients) || !IsClientInGame(client) || (IsFakeClient(client) && !bAllowBots) || (!IsPlayerAlive(client) && !bAllowDead))
	{
		return false;
	}
	return true;
}

bool HasFlags(int client, char[] sFlags)
{
	if(StrEqual(sFlags, "public", false) || StrEqual(sFlags, "", false))
	{
		return true;
	}
	else if(StrEqual(sFlags, "none", false))	//useful for some plugins
	{
		return false;
	}
	else if(!client)	//if rcon
	{
		return true;
	}
	else if(CheckCommandAccess(client, "sm_not_a_command", ADMFLAG_ROOT, true))
	{
		return true;
	}
	
	AdminId id = GetUserAdmin(client);
	if(id == INVALID_ADMIN_ID)
	{
		return false;
	}
	int flags, clientflags;
	clientflags = GetUserFlagBits(client);
	
	if(StrContains(sFlags, ";", false) != -1) //check if multiple strings
	{
		int i = 0, iStrCount = 0;
		while(sFlags[i] != '\0')
		{
			if(sFlags[i++] == ';')
			{
				iStrCount++;
			}
		}
		iStrCount++; //add one more for stuff after last comma
		
		char[][] a_sTempArray = new char[iStrCount][30];
		ExplodeString(sFlags, ";", a_sTempArray, iStrCount, 30);
		bool bMatching = true;
		
		for(i = 0; i < iStrCount; i++)
		{
			bMatching = true;
			flags = ReadFlagString(a_sTempArray[i]);
			for(int j = 0; j <= 20; j++)
			{
				if(bMatching)	//if still matching, continue loop
				{
					if(flags & (1<<j))
					{
						if(!(clientflags & (1<<j)))
						{
							bMatching = false;
						}
					}
				}
			}
			if(bMatching)
			{
				return true;
			}
		}
		return false;
	}
	else
	{
		flags = ReadFlagString(sFlags);
		for(int i = 0; i <= 20; i++)
		{
			if(flags & (1<<i))
			{
				if(!(clientflags & (1<<i)))
				{
					return false;
				}
			}
		}
		return true;
	}
}

stock void Log(char[] sPath, const char[] sMsg, any ...)		//TOG logging function - path is relative to logs folder.
{
	char sLogFilePath[PLATFORM_MAX_PATH], sFormattedMsg[1500];
	BuildPath(Path_SM, sLogFilePath, sizeof(sLogFilePath), "logs/%s", sPath);
	VFormat(sFormattedMsg, sizeof(sFormattedMsg), sMsg, 3);
	LogToFileEx(sLogFilePath, "%s", sFormattedMsg);
}

stock bool HasOneFlag(int client, char[] sFlags)
{
	if(StrEqual(sFlags, "public", false) || StrEqual(sFlags, "", false))
	{
		return true;
	}
	else if(StrEqual(sFlags, "none", false))	//useful for some plugins
	{
		return false;
	}
	else if(!client)	//if rcon
	{
		return true;
	}
	else if(CheckCommandAccess(client, "sm_not_a_command", ADMFLAG_ROOT, true))
	{
		return true;
	}
	
	AdminId id = GetUserAdmin(client);
	
	if(id != INVALID_ADMIN_ID)
	{
		int iCount, flags = ReadFlagString(sFlags);
		iCount = 0;
		for(int i = 0; i <= 20; i++)
		{
			if(flags & (1<<i))
			{
				iCount++;

				if(GetAdminFlag(id, view_as<AdminFlag>(i)))
				{
					return true;
				}
			}
		}
	}

	return false;
}

int SearchForPlayer(const char[] targetstring)
{
	char sName[MAX_NAME_LENGTH];
	int iNumberFound = 0;

	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i))
		{
			GetClientName(i, sName, sizeof(sName));
			
			if(StrContains(sName, targetstring, false) != -1)
			{
				iNumberFound++;
			}
		}
	}
	return iNumberFound;
}

/*
CHANGELOG:
	1.x
		*	Initial creation and all modifications before changelog was started.
	1.1.0
		*	Converted to new syntax (partially - not using classes).
		*	Added unlimited ammo flag.
*/